/**
 * Smooth Line Chart
 */
class SmoothLineChart extends PointChart {
    /**
     * Creates a new instance of the SmoothLineChart class
     *
     * @param {HTMLCanvasElement} canvas - The canvas element to draw the chart on
     * @param {Array<Object>} data - The data to visualize on the chart
     * @param {Object} settings - The settings for the chart
     * @param {ZoomManager} zoom - The zoom manager for the chart.
     */
    constructor(canvas, data, settings, zoom) {
        // Call the constructor of the parent class (PointChart)
        super(canvas, data, settings, zoom)
    }

    /**
     * Draws the smooth line chart on the canvas.
     * @param {Boolean} async - Says if the chart should be drawn synchronously or asynchronously
     */
    draw(async = true) {
        // Clear the canvas and draw the axis
        this.clear()
        this.drawAxis()

        // Define function for async
        let fn = () => {
            // Iterate over each category in the data
            this.data.forEach(categ => {
                // Begin a new path for drawing lines
                this.ctx.beginPath()
                this.ctx.lineJoin = "round"
                this.ctx.strokeStyle = categ.color

                // Calculate the starting point for the line
                let pos1 = this.getPointPos(0, categ.values[0])
                this.ctx.moveTo(pos1.x, pos1.y)

                // Draw the Bezier curve for the smooth line
                for (let i = 0; i < this.dataLen - 1; i++) {
                    // Calculate left point coordinates
                    let leftPos = this.getPointPos(i, categ.values[i])

                    // Calculate right point coordinates
                    let rightPos = this.getPointPos(i + 1, categ.values[i + 1])

                    // Find middle point
                    let xm = (leftPos.x + rightPos.x) / 2
                    // Find quarter points
                    let xl = (leftPos.x + xm) / 2
                    let xr = (rightPos.x + xm) / 2

                    // Draw a curve that smoothly connects the points
                    this.ctx.bezierCurveTo(xl, leftPos.y, xr, rightPos.y, rightPos.x, rightPos.y);
                }
                this.ctx.stroke()
                this.ctx.closePath()
            })

            // Draw points on the chart if required
            if (this.settings.displayPoints)
                this.data.forEach((categ, colId) => { this.drawPoints(categ.values, colId, categ.color) })
        }

        // Draw the chart
        async ? setTimeout(() => fn(), 0) : fn()
    }
}
